;######################################################################## 
;######################################################################## 
;######################################################################## 
TWI_INI:
	; TWI TWCR 				Control-REGISTER	
	ldi temp, 1<<TWINT|1<<TWEA|0<<TWSTA|0<<TWSTO|0<<TWWC|1<<TWEN|1<<TWIE
	out TWCR,temp
	; TWI TWAR (nur SLAVE) 	Adress-Register		
	ldi temp,(TWI_SLAVE_ADRESSE<<TWA0 | TWI_GENERAL_CALL_ENABLE<<TWGCE)
	out TWAR,temp
ret
; #############################################################################
; #############################################################################
; #############################################################################
TWI_ERROR:
	; STOP		
	ldi temp, 1<<TWINT|1<<TWSTO|1<<TWEN|1<<TWIE  ; STOP  => wichtig
	out TWCR,temp
	ldi temp, 1<<TWINT|1<<TWSTO|1<<TWEN|1<<TWIE  ; STOP  => wichtig
	out TWCR,temp
	ldi temp, 1<<TWINT|1<<TWSTO|1<<TWEN|1<<TWIE  ; STOP  => wichtig
	out TWCR,temp
	ldi temp, 1<<TWINT|1<<TWSTO|1<<TWEN|1<<TWIE  ; STOP  => wichtig
	out TWCR,temp
	ldi temp, 1<<TWINT|1<<TWSTO|1<<TWEN|1<<TWIE  ; STOP  => wichtig
	out TWCR,temp
	ldi temp, 1<<TWINT|1<<TWSTO|1<<TWEN|1<<TWIE  ; STOP  => wichtig
	out TWCR,temp
	ldi temp, 1<<TWINT|1<<TWSTO|1<<TWEN|1<<TWIE  ; STOP  => wichtig
	out TWCR,temp
	ldi temp, 1<<TWINT|1<<TWSTO|1<<TWEN|1<<TWIE  ; STOP  => wichtig
	out TWCR,temp
	ldi temp, 1<<TWINT|1<<TWSTO|1<<TWEN|1<<TWIE  ; STOP  => wichtig
	out TWCR,temp
	ldi temp, 1<<TWINT|1<<TWSTO|1<<TWEN|1<<TWIE  ; STOP  => wichtig
	out TWCR,temp
	; FEHLERPRFUNG
	in temp, TWSR
	andi temp,0b11111000
	cpi  temp,0b11111000
	brne TWI_ERROR_SCHWER	
	ret
;--------------------------------------------------------------
TWI_ERROR_SCHWER:


ret
; #############################################################################
; #############################################################################
; #############################################################################
;																				
; TWI INTERRUPPT-Routine														
;																				
TWSI:
	push TEMP
	in TEMP,SREG	     ; Schreiben von  SREG  im Stack (KOPIE)	
	push temp
	push temp1           ; temp1 auf dem Stack sichern            	
;-------------------------------------------------------------------------------
	in temp, TWSR		; TWI- Status-Register abfragen							
	andi temp, 0xF8		; Bit0...2 ausblenden (Prescaler und Reserve-Bit)		
;-------------------------------------------------------------------------------
TWSI_TWSR_AUSWERTEN:
	;	vergleich		
	cpi temp, TW_SR_SLA_ACK			 	; x60
	breq TWSI_TW_SR_SLA_ACK
	cpi temp, TW_SR_ARB_LOST_SLA_ACK 	; x68
	breq TWSI_TW_SR_ARB_LOST_SLA_ACK
	cpi temp, TW_SR_GCALL_ACK			; x70
	breq TWSI_TW_SR_GCALL_ACK
	cpi temp, TW_SR_ARB_LOST_GCALL_ACK	; x78
	breq TWSI_TW_SR_ARB_LOST_GCALL_ACK
	cpi temp, TW_SR_DATA_ACK      		; x80
	breq TWSI_TW_SR_DATA_ACK      	
	cpi temp, TW_SR_DATA_NACK      		; x88
	breq TWSI_TW_SR_DATA_NACK
	cpi temp, TW_SR_GCALL_DATA_ACK   	; x90
	breq TWSI_TW_SR_GCALL_DATA_ACK   
	cpi temp, TW_SR_GCALL_DATA_NACK		; x98
	breq TWSI_TW_SR_GCALL_DATA_NACK
	cpi temp, TW_SR_STOP        		; xA0
	breq TWSI_TW_SR_STOP        	
; 	
	cpi temp, TW_ST_SLA_ACK        		; 0xA8
	breq TWSI_TW_ST_SLA_ACK	
	cpi temp, TW_ST_ARB_LOST_SLA_ACK	; 0xB0
	breq TWSI_TW_ST_ARB_LOST_SLA_ACK
	cpi temp, TW_ST_DATA_ACK      		; 0xB8
	breq TWSI_TW_ST_DATA_ACK
	cpi temp, TW_ST_DATA_NACK      		; 0xC0
	breq TWSI_TW_ST_DATA_NACK
	cpi temp, TW_ST_LAST_DATA      		; 0xC8
	breq TWSI_TW_ST_LAST_DATA 
	cpi temp, TW_NO_INFO        		; 0xF8
	breq TWSI_TW_NO_INFO
	cpi temp, TW_BUS_ERROR        		; 0x00 (Error)
	breq TWSI_TW_BUS_ERROR 
	rjmp TWSI_ANTWORT					; nicht behandelte Status-Zustnde	
;---------------------------------------------------------------------------------------
; MASTER TRANSMITTER				
TWSI_TW_SR_SLA_ACK:						; x60 ("SLA+W" wurde empfangen) 				
	; START				
	; ZEIGER auf NULL	
	STS(adr_DAC_ZEIGER),NULL
	STS(adr_TWI_AKTIVITAET),EINS; LED an				
	rjmp TWSI_ANTWORT
;---------------------------------------------------------------------------------------
TWSI_TW_SR_ARB_LOST_SLA_ACK:			; x68 (Arbitration verloren)					
	; NIX tun			
	rjmp TWSI_ANTWORT
TWSI_TW_SR_GCALL_ACK:					; x70 ("General Call" wurde empfangen)			
	; START "General Call"		
	rjmp TWSI_ANTWORT
TWSI_TW_SR_ARB_LOST_GCALL_ACK:			; x78 (Arbitration verloren)					
	; NIX tun			
	rjmp TWSI_ANTWORT
; MASTER TRANSMITTER				
TWSI_TW_SR_DATA_ACK:					; x80 ("SLA+W"-Datenbyte wurden empfangen) 		
	LDS temp,(adr_DAC_ZEIGER)
	inc temp
	; berlauf	
	tst temp
	breq TWSI_TW_SR_DATA_ACK_w
	STS (adr_DAC_ZEIGER),temp
TWSI_TW_SR_DATA_ACK_w:
	; DATA				
	in temp1, TWDR				; Datenbyte auslesen
	cpi temp,1
	breq TWSI_TW_SR_DATA_ACK_B0
	cpi temp,2
	breq TWSI_TW_SR_DATA_ACK_B1
	cpi temp,3
	breq TWSI_TW_SR_DATA_ACK_B2
	rjmp TWSI_ANTWORT
TWSI_TW_SR_DATA_ACK_B0:
	STS(adr_DAC_BYTE0),temp1	; Datenbyte speichern	
	rjmp TWSI_ANTWORT
TWSI_TW_SR_DATA_ACK_B1:
	STS(adr_DAC_BYTE1),temp1	; Datenbyte speichern	
	rjmp TWSI_ANTWORT
TWSI_TW_SR_DATA_ACK_B2:
	STS(adr_DAC_BYTE2),temp1	; Datenbyte speichern	
	rcall DAC_AUSWERTUNG		; Datenbyte auswerten	
	rjmp TWSI_ANTWORT
;-----------------------------------------------------------------
TWSI_TW_SR_DATA_NACK:      				; x88 (die vorher adressierten (SLA+W) Daten wurden empfangen; ACK wurde nicht zurckgesedet
	; NIX tun			
	rjmp TWSI_ANTWORT
TWSI_TW_SR_GCALL_DATA_ACK:				; x90 ("General Call"-Datenbyte wurden empfangen)	
	; DATA				
	in temp1, TWDR		
	rjmp TWSI_ANTWORT
TWSI_TW_SR_GCALL_DATA_NACK:				; x98 (die vorher adressierten (General call) Daten wurden empfangen;  ACK wurde nicht zurckgesendet	
	; NIX tun			
	rjmp TWSI_ANTWORT
TWSI_TW_SR_STOP:						; xA0 (STOP oder Repead-START wurde empfangen)
	; STOP				
	rjmp TWSI_ANTWORT
;	SLAVE TRANSMITTER					
TWSI_TW_ST_SLA_ACK:						; xA8 (SLA+R wurde empfangen) + ACK 
	; DATA			
	ldi temp1,'D'
	OUT TWDR, temp1						; DATA zur Verfgung stellen
	rjmp TWSI_ANTWORT
TWSI_TW_ST_ARB_LOST_SLA_ACK:			; xB0 (Arbitration verlor SLA+R/W als MASTER, ACK wurde zurckgesendet)	
	rjmp TWSI_ANTWORT
TWSI_TW_ST_DATA_ACK:					; xB8 (DATEN wurden bertragen) + ACK 	
	; DATA			
	ldi temp1,'d'
	OUT TWDR, temp1						; DATA zur Verfgung stellen
	rjmp TWSI_ANTWORT
TWSI_TW_ST_DATA_NACK:					; xC0 (TWDR ist bertragen worden;  ACK ist NICHT empfangen worden
	ldi temp,'C'	
	OUT TWDR, temp						; DATA zur Verfgung stellen
	rjmp TWSI_ANTWORT
TWSI_TW_ST_LAST_DATA:					; xC8 (Letztes Datenbyte in TWDR ist bertragen worden (TWEA = "0");  Ack ist empfangen worden
	ldi temp,'D'
	OUT TWDR, temp						; DATA zur Verfgung stellen
	rjmp TWSI_ANTWORT
	; NO INFO		
TWSI_TW_NO_INFO:						; xF8 (Keine relevanten Zustandinformationen vorhanden;  TWINT = "0" keine TWDR-Ttigkeit 
	rjmp TWSI_ANTWORT

; ERROR									
TWSI_TW_BUS_ERROR:						; x00 (Bus-Error wegen ungltige STARToder STOP BEDIgung; keine TWDR-Ttigkeit 
	rcall TWI_ERROR	
	rjmp TWSI_ANTWORT
;--------------------------------------
TWSI_ANTWORT:	
	; ANTWORTEN							
	ldi temp, 1<<TWINT|1<<TWEA|1<<TWEN|1<<TWIE
	out TWCR,temp
;--------------------------------------
TWSI_FERTIG:
		pop temp1
		pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
		out	SREG,TEMP		; Wiederherstellen von SREG
		pop	TEMP				; LESEN von SREG vom STACK (KOPIE)
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
TWI_BUS_FREE_CHECK:
	in temp,PINC
	com temp
	andi temp,0b00110000
	; Schleife, bis WDR zubeit	
	tst temp
	brne TWI_BUS_FREE_CHECK
ret
; #############################################################################
; #############################################################################
; #############################################################################

