; TWI/I2C 20Bit DAC								
; Bernhard.Erfurt@gmx.de						
; 03/2013										
;												

; PROTOKOLL SLAVE=>MASTER						
; BYTE-0 ==> DAC-BYTE0							
; BYTE-1 ==> DAC-BYTE1							
; BYTE-2 ==> DAC-BYTE2							


;												
; Anschlussbelegung PINS						
;												
; Aref==> LED gelb (High-Aktiv)					
;												
; PB0 ==> DAC-NETZWERK							
; PB1 ==> DAC-NETZWERK							
; PB2 ==> DAC-NETZWERK							
; PB3 ==> DAC-NETZWERK							
; PB4 ==> DAC-NETZWERK							
; PB5 ==> DAC-NETZWERK							
; PB6 ==> DAC-NETZWERK							
; PB7 ==> DAC-NETZWERK							
;												
; PC0 ==> DAC-NETZWERK							
; PC1 ==> DAC-NETZWERK							
; PC2 ==> DAC-NETZWERK							
; PC3 ==> DAC-NETZWERK							
; PC4 ==> SDA (gelb)							
; PC5 ==> SCL (grn)							
;												
; PD0 ==> DAC-NETZWERK							
; PD1 ==> DAC-NETZWERK							
; PD2 ==> DAC-NETZWERK							
; PD3 ==> DAC-NETZWERK							
; PD4 ==> DAC-NETZWERK							
; PD5 ==> DAC-NETZWERK							
; PD6 ==> DAC-NETZWERK							
; PD7 ==> DAC-NETZWERK							
;												


; ATmega8 										
.include "m8def.inc"
; SLAVE-ADRESSE									
.equ TWI_SLAVE_ADRESSE		=120
; GENERAL CALL									
.equ TWI_GENERAL_CALL_ENABLE=0
; R-NETZWERK (PIN)									
.equ PIN_BYTE0_BIT0				= 3		; (LOW)
.equ PIN_BYTE0_BIT1				= 2
.equ PIN_BYTE0_BIT2				= 1
.equ PIN_BYTE0_BIT3				= 0
.equ PIN_BYTE0_BIT4				= 5
.equ PIN_BYTE0_BIT5				= 4
.equ PIN_BYTE0_BIT6				= 3
.equ PIN_BYTE0_BIT7				= 2

.equ PIN_BYTE1_BIT0				= 1
.equ PIN_BYTE1_BIT1				= 0
.equ PIN_BYTE1_BIT2				= 7
.equ PIN_BYTE1_BIT3				= 6
.equ PIN_BYTE1_BIT4				= 5
.equ PIN_BYTE1_BIT5				= 7
.equ PIN_BYTE1_BIT6				= 6
.equ PIN_BYTE1_BIT7				= 4

.equ PIN_BYTE2_BIT0				= 3
.equ PIN_BYTE2_BIT1				= 2
.equ PIN_BYTE2_BIT2				= 1
.equ PIN_BYTE2_BIT3				= 0		; (HIGH)

; R-NETZWERK (PORT)									
.equ PORT_BYTE0_BIT0			= PORTC
.equ PORT_BYTE0_BIT1			= PORTC
.equ PORT_BYTE0_BIT2			= PORTC
.equ PORT_BYTE0_BIT3			= PORTC
.equ PORT_BYTE0_BIT4			= PORTB
.equ PORT_BYTE0_BIT5			= PORTB
.equ PORT_BYTE0_BIT6			= PORTB
.equ PORT_BYTE0_BIT7			= PORTB

.equ PORT_BYTE1_BIT0			= PORTB
.equ PORT_BYTE1_BIT1			= PORTB
.equ PORT_BYTE1_BIT2			= PORTD
.equ PORT_BYTE1_BIT3			= PORTD
.equ PORT_BYTE1_BIT4			= PORTD
.equ PORT_BYTE1_BIT5			= PORTB
.equ PORT_BYTE1_BIT6			= PORTB
.equ PORT_BYTE1_BIT7			= PORTD

.equ PORT_BYTE2_BIT0			= PORTD
.equ PORT_BYTE2_BIT1			= PORTD
.equ PORT_BYTE2_BIT2			= PORTD
.equ PORT_BYTE2_BIT3			= PORTD



; TWI Slave Receiver Codes						
.equ TW_SR_SLA_ACK        	= 0x60
.equ TW_SR_ARB_LOST_SLA_ACK = 0x68
.equ TW_SR_GCALL_ACK      	= 0x70
.equ TW_SR_ARB_LOST_GCALL_ACK=0x78
.equ TW_SR_DATA_ACK      	= 0x80
.equ TW_SR_DATA_NACK      	= 0x88
.equ TW_SR_GCALL_DATA_ACK   = 0x90
.equ TW_SR_GCALL_DATA_NACK  = 0x98
.equ TW_SR_STOP        		= 0xA0
; TWI Slave Transmitter Codes					
.equ TW_ST_SLA_ACK        	= 0xA8
.equ TW_ST_ARB_LOST_SLA_ACK = 0xB0
.equ TW_ST_DATA_ACK      	= 0xB8
.equ TW_ST_DATA_NACK      	= 0xC0
.equ TW_ST_LAST_DATA      	= 0xC8
.equ TW_NO_INFO        		= 0xF8
.equ TW_BUS_ERROR        	= 0x00
; SRAM-BELEGUNG ATmega8							
.equ adr_DATEN				= SRAM_START			; 0x0060 START Adresse 		

.equ adr_TWI_AKTIVITAET		= SRAM_START+2

.equ adr_DAC_ZEIGER			= SRAM_START+50			; TWI-DAC-ZEIGER
.equ adr_DAC_BYTE0			= SRAM_START+51			; DAC			
.equ adr_DAC_BYTE1			= SRAM_START+52			; DAC			
.equ adr_DAC_BYTE2			= SRAM_START+53			; DAC	

.equ adr_SRAM_CHECK			= SRAM_START+900


; REGISTER										

.def NULL 	= R10
.def EINS 	= R11
.def VOLL	= R12

.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25

.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp INTERRUPT_ERROR	;rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR  	; Timer1 Overflow Handler           					
rjmp INTERRUPT_ERROR  	;rjmp TIM0_OVF	;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR 	; USART RX Complete Handler         					
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp TWSI       		; Two-wire Serial Interface Handler 					
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	


; Bei unkorrekten Interrupt aufrufen erfolgt ein RESET ber WDR	
INTERRUPT_ERROR:
	rcall LED_GELB_AN
	rcall wait_100ms
	rcall LED_GELB_AUS
	rcall wait_100ms
	rjmp INTERRUPT_ERROR

RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; SRAM CLEAR										
SRAM_CLEAR:
	ldi ZL, LOW (adr_DATEN)
	ldi ZH, HIGH(adr_DATEN)
	clr temp
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND); Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND)	; Vergleich?		
	brlo SRAM_CLEAR_w	; kleiner => SPRUNG	
	breq SRAM_CLEAR_w	; gleich  => SPRUNG	
; PORT B initialisieren								
	ldi temp, 0b11111111	; R/R/R/R/R/R/R/R	
	out DDRB, temp
; PORT B setzen										
	ldi temp, 0b00000000	
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00001111	; SDA/SCL/R/R/R/R	
	out DDRC, temp
; PORT C setzen										
	ldi temp, 0b00000000
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b11111111	; R/R/R/R/R/R/R/R	
	out DDRD, temp			
; PORT D setzen										
	ldi temp, 0b00000000
	out PORTD, temp				
; Watchdog aktivieren (max. Zeit)					
	rcall Watchdog_aktivieren
; NEUSTART_MIT_WDR									
	rcall NEUSTART_MIT_WDR
; I2C/TWI INITIALISIEREN							
	rcall TWI_INI
; Startwerte										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
	; SRAM-CHECK		
	ldi temp,'S'
	STS(adr_SRAM_CHECK),temp
	; DAC auf 50%	
	ldi temp1,BYTE1(0x0FFFFF/2)
	ldi temp2,BYTE2(0x0FFFFF/2)
	ldi temp3,BYTE3(0x0FFFFF/2)
	STS (adr_DAC_BYTE0),temp1
	STS (adr_DAC_BYTE1),temp2
	STS (adr_DAC_BYTE2),temp3
	rcall DAC_AUSWERTUNG
	; LED-BLINKEN	
	rcall LED_GELB_AN
	rcall wait_100ms
	rcall LED_GELB_AUS
	rcall wait_100ms
	rcall LED_GELB_AN
	rcall wait_100ms
	rcall LED_GELB_AUS
	rcall wait_100ms
	rcall LED_GELB_AN
	rcall wait_100ms
	rcall LED_GELB_AUS
	rcall wait_100ms
; interrupts freigeben								
	sei

; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:
	WDR
	rcall PROGRAMM_CHECK
	rcall TWI_BUS_FREE_CHECK
	LDS temp,(adr_TWI_AKTIVITAET)
	tst temp
	breq LOOP
;-------------------------------------------------------------------------------
	STS(adr_TWI_AKTIVITAET),NULL

	rcall LED_GELB_AN
	rcall wait_100ms
	rcall LED_GELB_AUS

rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################

.include "DAC_SONSTIGES.asm"
.include "DAC_DAC.asm"
.include "DAC_I2C_SLAVE.asm"
;.include "DAC_WAIT_01MHZ.asm"
.include "DAC_WAIT_08MHZ.asm"
; ##############################################################################
; ##############################################################################
; ##############################################################################





